#ifndef BIOS_H
#define BIOS_H

#if defined(__cplusplus)
extern "C" {
#endif

#include <avr/pgmspace.h>
#include <stdbool.h>
#include <stdint.h>

#include "boot.h"

#define watchDogReset() __asm__ __volatile__("wdr\n")

#define startApp()                                                             \
  __asm__ __volatile__("jmp 0x0000"                                            \
                       "\n\t"                                                  \
                       :                                                       \
                       :                                                       \
                       :)

#define canboot_jumpTable                                                      \
  __asm__ __volatile__("rjmp bios_getNodeName"                                 \
                       "\n\t"                                                  \
                       "rjmp boot_read"                                        \
                       "\n\t"                                                  \
                       "rjmp boot_write"                                       \
                       "\n\t"                                                  \
                       "rjmp boot_strmatch_P"                                  \
                       "\n\t"                                                  \
                       "rjmp boot_nextParameter"                               \
                       "\n\t"                                                  \
                       :                                                       \
                       :                                                       \
                       :)

#if defined(__cplusplus)
}
#endif

#endif /* BIOS_H */
