#ifndef BOOT_H
#define BOOT_H

#if defined(__cplusplus)
extern "C" {
#endif

#include <avr/pgmspace.h>

#include "canboot.h"
#include "hal.h"

typedef struct {
  char nodeName[7];
  char nodeSerial[7];
  char nodeBuild[7];
  char boot_P[4];
  char ok_P[3];
  char err_P[4];
} node_t;

#define xstr(s) sstr(s)
#define sstr(s) #s

#define BUILD_STR xstr(BUILD)
#define SERIAL_STR xstr(SERIAL)


// node name can be up to 6 characters
#define node_config                                                            \
  { NODE_STR, SERIAL_STR, BUILD_STR, "/!/", "ok", "err" }

extern const node_t nodeConfig;

uint8_t boot_read(uint8_t *buffer);
uint8_t boot_write(uint8_t *buffer, uint8_t priority);
void boot_sendResponse(uint8_t *buffer, PGM_P response);
uint8_t boot_strmatch_P(uint8_t *str, PGM_P pstr);
uint8_t *boot_nextParameter(uint8_t *data);
uint8_t *boot_stradd_P(uint8_t *str, PGM_P pstr);

#if defined(__cplusplus)
}
#endif

#endif /* BOOT_H_ */
