#ifndef DEBUG_H_
#define DEBUG_H_

#define AMBER_DEBUG(x)                                                         \
  do {                                                                         \
    DDRD |= (1 << PORTD5);                                                     \
    uint8_t y = x;                                                             \
    while (y--) {                                                              \
      PORTD |= (1 << PORTD5);                                                  \
      PORTD &= ~(1 << PORTD5);                                                 \
    }                                                                          \
  } while (0)

#define CLK_DEBUG(x)                                                           \
  do {                                                                         \
    DDRB |= (1 << PORTB5);                                                     \
    uint8_t y = x;                                                             \
    while (y--) {                                                              \
      PORTB |= (1 << PORTB5);                                                  \
      PORTB &= ~(1 << PORTB5);                                                 \
    }                                                                          \
  } while (0)

#define MISO_DEBUG(x)                                                          \
  do {                                                                         \
    DDRB |= (1 << PORTB4);                                                     \
    uint8_t y = x;                                                             \
    while (y--) {                                                              \
      PORTB |= (1 << PORTB4);                                                  \
      PORTB &= ~(1 << PORTB4);                                                 \
    }                                                                          \
  } while (0)

#define GREEN_TOGGLE()                                                         \
  do {                                                                         \
    DDRD |= (1 << PORTD6);                                                     \
    PORTD ^= (1 << PORTD6);                                                    \
  } while (0)
#define GREEN_ON()                                                             \
  do {                                                                         \
    DDRD |= (1 << PORTD6);                                                     \
    PORTD |= (1 << PORTD6);                                                    \
  } while (0)
#define GREEN_OFF()                                                            \
  do {                                                                         \
    DDRD |= (1 << PORTD6);                                                     \
    PORTD &= ~(1 << PORTD6);                                                   \
  } while (0)

#define RED_TOGGLE()                                                           \
  do {                                                                         \
    DDRD |= (1 << PORTD3);                                                     \
    PORTD ^= (1 << PORTD3);                                                    \
  } while (0)
#define RED_ON()                                                               \
  do {                                                                         \
    DDRD |= (1 << PORTD3);                                                     \
    PORTD |= (1 << PORTD3);                                                    \
  } while (0)
#define RED_OFF()                                                              \
  do {                                                                         \
    DDRD |= (1 << PORTD3);                                                     \
    PORTD &= ~(1 << PORTD3);                                                   \
  } while (0)

#define AMBER_TOGGLE()                                                         \
  do {                                                                         \
    DDRD |= (1 << PORTD5);                                                     \
    PORTD ^= (1 << PORTD5);                                                    \
  } while (0)
#define AMBER_ON()                                                             \
  do {                                                                         \
    DDRD |= (1 << PORTD5);                                                     \
    PORTD |= (1 << PORTD5);                                                    \
  } while (0)
#define AMBER_OFF()                                                            \
  do {                                                                         \
    DDRD |= (1 << PORTD5);                                                     \
    PORTD &= ~(1 << PORTD5);                                                   \
  } while (0)

#endif
