#ifndef EEPROM_h
#define EEPROM_h

#include <inttypes.h>
#include <avr/eeprom.h>
#include <avr/io.h>


int eepromRead(uint8_t address){
  return (int)eeprom_read_word((uint16_t*)((uint16_t)address * 2));
}

void eepromWrite(uint8_t address, int value){
  eeprom_write_word((uint16_t*)((uint16_t)address * 2), (uint16_t)value);
}

void eepromUpdate(uint8_t address, int value){
  uint16_t data = eeprom_read_word((uint16_t*)((uint16_t)address * 2));
  if(data != (uint16_t)value){
    eeprom_write_word((uint16_t*)((uint16_t)address * 2), (uint16_t)value);
  }
}

#endif
