#ifndef DUTYCYCLE_H_
#define DUTYCYCLE_H_

#include "Arduino.h"
#include "Units.h"

class DutyCycle : public IRegister {
public:
  void getValue(uint8_t *request) {
    intToString(request, analogRead(SSR_DRIVE), Unit);
  }
  bool setValue(uint8_t *request) {
    analogWrite(SSR_DRIVE, atoi((char *)request));
    return true;
  }
  PGM_P getName() { return PSTR("duty"); }
  PGM_P getLabel() { return PSTR("DutyCycle"); }
  PGM_P getUnits() { return Units_kVoltsString; }
};

DutyCycle dutyCycle;

#endif /* DUTYCYCLE_H_ */
