#ifndef REGISTERANALOG_H_
#define REGISTERANALOG_H_

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunused-parameter"

#include "Arduino.h"
#include <avr/pgmspace.h>
#include <stdint.h>

#include "RegisterIO.h"

class RegisterAnalog : public IRegister {
public:

  RegisterAnalog(const RegisterIO_t *analogChannel) { ac = analogChannel; }

  void getValue(uint8_t *request) {
    intToString(request, analogRead(pgm_read_byte(&(ac->channel))),
                pgm_read_byte(&(ac->scale)));
  }
  bool setValue(uint8_t *request) { return false; }

  PGM_P getName() { return (PGM_P)pgm_read_word((&ac->name)); }
  PGM_P getLabel() { return (PGM_P)pgm_read_word((&ac->label)); }
  PGM_P getUnits() { return (PGM_P)pgm_read_word((&ac->units)); }

private:
  const RegisterIO_t *ac;
};

#pragma GCC diagnostic pop

#endif /* REGISTERANALOG_H_ */
