#ifndef REGISTEREEPROM_H_
#define REGISTEREEPROM_H_

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunused-parameter"

#include "Arduino.h"
#include <avr/pgmspace.h>
#include <stdint.h>

#include "RegisterIO.h"

class RegisterEEPROM : public IRegister {
public:
  RegisterEEPROM(const RegisterIO_t *eeChannel) { ee = eeChannel; }

  void getValue(uint8_t *request) {
    intToString(request, eepromRead(pgm_read_byte(&(ee->channel))),
                pgm_read_byte(&(ee->scale)));
  }

  bool setValue(uint8_t *request) {
    int value = atoi((char *)request);
    unsigned char channel = pgm_read_byte(&(ee->channel));
    if (value != eepromRead(channel)) {
      eepromWrite(channel, value);
    }
    return true;
  }

  PGM_P getName() { return (PGM_P)pgm_read_word((&ee->name)); }
  PGM_P getLabel() { return (PGM_P)pgm_read_word((&ee->label)); }
  PGM_P getUnits() { return (PGM_P)pgm_read_word((&ee->units)); }

private:
  const RegisterIO_t *ee;
};

#pragma GCC diagnostic pop

#endif /* REGISTERANALOG_H_ */
