#ifndef REGISTERSRAM_H_
#define REGISTERSRAM_H_

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunused-parameter"

#include "Arduino.h"
#include <avr/pgmspace.h>
#include <stdint.h>

#include "RegisterIO.h"

class RegisterSRAM : public IRegister {
public:
  RegisterSRAM(const RegisterIO_t *sramChannel) { sram = sramChannel; }

  void getValue(uint8_t *request) {
    intToString(request, reg, pgm_read_byte(&(sram->scale)));
  }
  int16_t getValue(void) {
    return reg;
  }
  bool setValue(uint8_t *request) { 
    reg = atoi((char *)request);
    return true; 
  }
  bool setValue(int16_t value) {reg = value; return true; }

  PGM_P getName() { return (PGM_P)pgm_read_word((&sram->name)); }
  PGM_P getLabel() { return (PGM_P)pgm_read_word((&sram->label)); }
  PGM_P getUnits() { return (PGM_P)pgm_read_word((&sram->units)); }

private:
  const RegisterIO_t *sram;
  int16_t reg = 0;
};

#pragma GCC diagnostic pop

#endif /* REGISTERANALOG_H_ */
