#ifndef VOLTAGE_H_
#define VOLTAGE_H_

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunused-parameter"

#include "Arduino.h"
#include "Units.h"

class Voltage : public IRegister {
public:
  void getValue(uint8_t *request) {
    intToString(request, analogRead(VBATAVG), Milli);
  }
  bool setValue(uint8_t *request) { return false; }
  PGM_P getName() { return PSTR("v"); }
  PGM_P getLabel() { return PSTR("BatteryVoltage"); }
  PGM_P getUnits() { return Units_kVoltsString; }
};

Voltage voltage;

#pragma GCC diagnostic pop

#endif /* VOLTAGE_H_ */
