#ifndef ENUMERATE_H_
#define ENUMERATE_H_

#include "Arduino.h"

class Enumerate
{
public:
	Enumerate(PGM_P enumString) {this->enumList = enumString;}

	bool enumerator(char* buffer, int8_t value) {
		PGM_P ptr = enumList + 1;
		int8_t len = 0;
		char c;

		buffer[0] = 0;

		do {
			c = pgm_read_byte(ptr + len++);
			if((c == '|') || (c == ']')){
				if(value == 0){
					len--;
					memcpy_P(buffer, ptr, len);
					buffer[len] = 0;
					return true;
				}
				value--;
				ptr += len;
				len = 0;
			}
		} while(c);

		strcpy_P(buffer, INode_kErrorString);
		return false;
	}

	int8_t denumerator(char* buffer) {
		int8_t value = 0, len = 0;
		PGM_P ptr = enumList + 1;
		char c;

		do {
			c = pgm_read_byte(ptr + len++);
			if((c == '|') || (c == ']')){
				if(memcmp_P(buffer, ptr, strlen(buffer)) == 0) return value;
				value++;
				ptr += len;
				len = 0;
			}
		} while(c);

		strcpy_P(buffer, INode_kErrorString);

		return -1;
	}

	PGM_P getEnumeratedList() {return enumList;}

private:
	PGM_P enumList;
};

#endif /* ENUMERATE_H_ */
