#ifndef NODE_H_
#define NODE_H_

#include <string.h>

#include "Arduino.h"
#include "INode.h"

class Node : public INode {
public:
  Node(PGM_P name, INode *list[]) {
    this->nodeName = name;
    this->nodeList = list;
  }

  void processRequest(uint8_t *request) {
    uint8_t *str = request;
    INode **i = nodeList;

    // from root list all direct children
    if (0 == *str) {
      strcpy_P((char *)str, INode_kOpenListString);
      while (*i) {
        if (i != nodeList) {
          strcat_P((char *)str, INode_kListSeperatorString);
        }
        strcat_P((char *)str, (*i)->getName());
        i++;
      }
      strcat_P((char *)str, INode_kCloseListString);
      return;
    }

    // search for child and despatch
    i = nodeList;
    while (*i) {
      if (canboot_kSame == canboot_strMatch(str, (*i)->getName())) {
        str = canboot_strNext(str);
        (*i)->processRequest(str);
        return;
      }
      i++;
    }

    // child not found
    str = canboot_strNext(str);
    strcpy_P((char *)str, INode_kNotFoundString);
    return;
  }

  PGM_P getName() { return nodeName; }

private:
  PGM_P nodeName;
  INode **nodeList;
};

#endif /* NODE_H_ */
