#ifndef REGISTER_H_
#define REGISTER_H_

#include "INode.h"
#include "IRegister.h"

class Register : public INode {
public:
  Register(IRegister *ireg) { this->reg = ireg; }

  void processRequest(uint8_t *request) {
    if (*request) {
      if (canboot_kSame == canboot_strMatch(request, Inode_kValueString)) {
        request = canboot_strNext(request);
        if (*request) {
          if (false == this->reg->setValue(request)) {
            strcpy_P((char *)request, INode_kReadOnlyString);
          }
        } else {
          this->reg->getValue(request);
        }
      } else if (canboot_kSame ==
                 canboot_strMatch(request, Inode_kLabelString)) {
        request = canboot_strNext(request);
        strcpy_P((char *)request, this->reg->getLabel());
      } else if (canboot_kSame ==
                 canboot_strMatch(request, Inode_kUnitsString)) {
        request = canboot_strNext(request);
        strcpy_P((char *)request, this->reg->getUnits());
      } else {
        request = canboot_strNext(request);
        strcpy_P((char *)request, INode_kNotFoundString);
      }
    } else {
      strcpy_P((char *)request, INode_kOpenListString);
      strcat_P((char *)request, Inode_kValueString);
      strcat_P((char *)request, INode_kListSeperatorString);
      strcat_P((char *)request, Inode_kLabelString);
      strcat_P((char *)request, INode_kListSeperatorString);
      strcat_P((char *)request, Inode_kUnitsString);
      strcat_P((char *)request, INode_kCloseListString);
    }
  }

  PGM_P getName() { return this->reg->getName(); }

private:
  IRegister *reg;
};

#endif /* REGISTER_H_ */
