#ifndef UNITS_H_
#define UNITS_H_

#include "ReadOnly.h"
#include "Arduino.h"
#include "Boolean.h"

class Units : public ReadOnly
{
public:
	Units(PGM_P units) : ReadOnly(units) {}

	PGM_P getName() {return Inode_kUnitsString;}
};

const char Units_kCelciusString[] PROGMEM = "Celcius";
const char Units_kAmpsString[] PROGMEM = "Amps";
const char Units_kVoltsString[] PROGMEM = "Volts";
const char Units_kTimeString[] PROGMEM = "Time";

Units Units_temperature = Units(Units_kCelciusString);
Units Units_current = Units(Units_kAmpsString);
Units Units_voltage = Units(Units_kVoltsString);
Units Units_time = Units(Units_kTimeString);
Units Units_boolean = Units(Boolean_kEnumString);

#endif // UNITS_H_
