#ifndef LOG_H_
#define LOG_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include "nv.h"

#define log_kRecordSize nv_kBlobSize

#define LOG_OK (0)
#define LOG_BUSY (-1)
#define LOG_ERROR (-2)

extern uint16_t readAddress;
extern uint16_t writeAddress;

// initialise log system
int8_t log_init(void);

// update any ongoing transactions with the log
int8_t log_update(void);

// reset the read index
int8_t log_reset(void);

// read next records into buffer
int8_t log_read(nv_blob_t *data);

// write u32 to log
int8_t log_write(nv_blob_t *data);

#ifdef __cplusplus
} // extern "C"
#endif

#endif /* LOG_H_ */
