#ifndef NV_H_
#define NV_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>

#include "protothreads/pt.h"
#include "twi.h"

#define nv_kBusy (-1)
#define nv_kOK (0)
#define nv_kError (1)

#define nv_kBlobSize (16)

typedef struct {
  uint8_t data[nv_kBlobSize];
} nv_blob_t;

void nv_init(void);
uint16_t nv_getSize(void);

// following functions must be called repeatedly until PT_ENDED or PT_EXITED
PT_THREAD(nv_read(uint16_t address, nv_blob_t *blob));
PT_THREAD(nv_write(uint16_t address, nv_blob_t *blob));
PT_THREAD(nv_erase(uint16_t address));
PT_THREAD(nv_isFree(uint16_t address));

#ifdef __cplusplus
} // extern "C"
#endif

#endif /* NV_H_ */
