/*
  twi.h - TWI/I2C library for Wiring & Arduino
  Copyright (c) 2006 Nicholas Zambetti.  All right reserved.
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef twi_h
#define twi_h

#ifdef __cplusplus
extern "C" {
#endif

#include <inttypes.h>

//#define ATMEGA8

#ifndef TWI_FREQ
#define TWI_FREQ 100000L
#endif

#define TWI_OK (0)
#define TWI_BUSY (-1)
#define TWI_ERROR (-2)

void twi_init(void);
void twi_read(uint8_t deviceAddress, uint8_t *data, uint8_t length);
void twi_write(uint8_t deviceAddress, uint8_t *data, uint8_t length);
int8_t twi_getStatus(void);

#ifdef __cplusplus
} // extern "C"
#endif

#endif
