#ifndef BUS_H
#define BUS_H

#if defined(__cplusplus)
extern "C" {
#endif

#include <stdint.h>

typedef enum {
  bus_kResponsePriority = 0, // send responses immediately
  bus_kHighPriority,         // highest priority - minimum additional wait
  bus_kMedPriority,          // Medium priority
  bus_kLowPriority,          // lowest priority - maximum additional wait
} bus_priority_t;

typedef enum {
  bus_kRXReceiving = 0,
  bus_kRXCompleted,
  bus_kRXAborted,
  bus_kTXSending,
  bus_kTXWaiting,
  bus_kTXCompleted,
  bus_kTXAborted,
} bus_status_t;

void bus_init(void);
uint8_t bus_read(uint8_t *buffer);
uint8_t bus_write(uint8_t *buffer, uint8_t priority);

#if defined(__cplusplus)
}
#endif

#endif
