#ifndef FRAME_H
#define FRAME_H

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>

#define frame_kStartOfFrame (':')
#define frame_kEndOfFrame ('\n')

// passed string buffer in format "{DATA}"
// returns string buffer in format ":{DATA}{CR}{ESC}[>{CSUM}{CSUM}{LF}"
void frame_enframe(uint8_t *dst, uint8_t *src);

// passed string buffer in format ":{DATA}{CR}{ESC}[>{CSUM}{CSUM}{LF}" or
// ":{DATA}{CR}{LF}" modifies string buffer to be in format "{DATA}" and returns
// true if the check sum is present and OK or if the check sum is absent
uint8_t frame_deframe(uint8_t *dst, uint8_t *src);

#ifdef __cplusplus
} // extern "C"
#endif

#endif // FRAME_H
