#include "parse.h"

uint8_t parse_match(uint8_t *astr, uint8_t *bstr) {
  uint8_t a, b;
  do {
    a = *astr++;
    b = *bstr++;
    if (a != b) {
      if (('/' == a) && (0 == b))
        return parse_kSame;
      if ((0 == a) && ('/' == b))
        return parse_kSame;
      if ('*' == a)
        return parse_kSimilar;
      else
        return parse_kDifferent;
    }
  } while ((a) && ('/' != a));
  return parse_kSame;
}

uint8_t *parse_next(uint8_t *str) {
  while (*str) {
    if ('/' == *str) {
      return (str + 1);
    }
    str++;
  }
  *str++ = '/';
  *str = 0;
  return str;
}

uint8_t *parse_block(uint8_t *astr, uint8_t const *bstr) {
  while (*bstr) {
    if (*astr != *bstr) {
      return NULL;
    }
    astr++;
    bstr++;
  }
  
  return astr;
}
