#include "hex2bin.h"

uint8_t hex2bin(uint8_t *hex)
{
  uint8_t *bin = hex;
	uint8_t count = 0;

	while(*hex){
		uint8_t val = *hex++ - '0';
		if(val > 9) val -= 7;
		if(val > 15) return 0;		// invalid character
		if(count++ & 0x01) *bin++ |= val; else *bin = val << 4;
	}
  if(count & 0x01) return 0;  // not an even number of characters
	return (count >> 1);
}

void bin2hex(uint8_t *bin, uint8_t size)
{
	uint8_t index = (size << 1);
	uint8_t* data = bin + size;

	bin += index;
	*bin-- = 0;				          // terminate string

	while(index--){
		uint8_t val;
		if(index & 0x01) val = *--data & 0x0F; else val = *data >> 4;
		if(val < 10) val += '0'; else val += 'A' - 10;
		*bin-- = val;
	}
}
