#ifndef LED_H_
#define LED_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>

typedef enum {
  led_kOff = 0, // green
  led_kPower1 = 1,
  led_kPower2 = 2,
  led_kPower3 = 3,
  led_kPower4 = 4,
  led_kPower5 = 5,
  led_kPowerMax = 6,
  led_kOn = 7,

  led_kFull = 8, // amber
  led_kUnderVolts = 9,
  led_kNoSpare = 10,

  led_kOverTemp = 11, // red
  led_kLineError = 12,

  led_kTestFloat = 13,
  led_kTestISense = 14,
  led_kTestFreq = 15,

  led_kRedOn = 16,
  led_kAmberOn = 17,
  led_kGreenOn = 18,
  
  led_kIsolError = 19,

  led_kStates

} led_status_t;

typedef enum {
  led_kRed = 0,
  led_kGreen = 1,
  led_kAmber = 2,
} led_bit_t;

// needs to be called every 10 ms, returns led mask
uint8_t led_update(uint8_t status);

#ifdef __cplusplus
} // extern "C"
#endif

#endif /* LED_H_ */
